package juego;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class Ayuda {

	private JFrame jFrame = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	private JPanel jContentPane = null;
	private JScrollPane jScrollPane = null;
	private JTextArea jTextArea = null;
	
	public Ayuda()
	{
		getJFrame().setVisible(true);
		
		//Volver arriba
		jTextArea.setSelectionStart(0);
		jTextArea.setSelectionEnd(0);

	}
	/**
	 * This method initializes jFrame
	 * 
	 * @return javax.swing.JFrame
	 */
	JFrame getJFrame() {
		if (jFrame == null) {
			jFrame = new JFrame();
			jFrame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
			jFrame.setSize(600, 400);
			jFrame.setContentPane(getJContentPane());
			jFrame.setTitle("Stratego Ayuda");
		}
		return jFrame;
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getJScrollPane(), BorderLayout.CENTER);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setText("Stratego\n\n" +
					"Un juego de habilidad y estrategia para dos jugadores.\n\n" +
					"Stratego es la versin americana del juego ahora es popular en el continente. Mientras que las piezas tienen diseos militares y se van colocando a travs del tablero de juego, no es un juego de guerra.\n\n" +
					"Stratego es un juego de movimiento rpido, que es fcil de aprender, muy agradable para jugar, y que ofrece una variedad sin fin de maneras de burlar a tu oponente. Las coloridas piezas del juego estn marcadas de acuerdo al rango militar que se mantiene oculto al oponente, ya que se colocan y se mueven a travs del tablero para capturar la bandera de tu oponente. El rango de la pieza se revela slo cuando una pieza oponente es golpeada o atacada. La pieza de mayor puntuacin elimina a la de menor rango. Hay bombas, que repelen cualquier pieza atacante excepto el minero que puede desmontar y retirar la bomba. Incluso el mariscal, el ms alto ranking de pieza, tiene una debilidad, es que los humildes espias le pueden quitar del juego.\n\n" +
					"Los elementos interesantes de planificacin hbil, astuto, engao, la memoria y el suspense hacen de Stratego un juego totalmente encantador.\n\n" +
					"Reglas de Stratego\n\n" +
					"El objetivo del juego es capturar la bandera de tu oponente.\n\n" +
					"Para comenzar el juego:\n\n" +
					"   1. Coloque el tablero entre los jugadores para que el nombre Stratego se enfrenta a cada concursante.\n" +
					"   2. Cada jugador toma las piezas del juego rojas o azules. Las rojas empiezan la partida.\n" +
					"   3. Cada jugador tiene un ejrcito de 40 piezas, con un rango de mayor a menor, que consiste en:\n\n" +
					"        1 Mariscal\n" +
					"        1 General\n" +
					"        2 Coroneles\n" +
					"        3 Comandates\n" +
					"        4 Capitanes\n" +
					"        4 Tenientes\n" +
					"        4 Sargentos\n" +
					"        5 Mineros\n" +
					"        8 Exploradores\n" +
					"        1 Espia\n\n" +
					"Estas son todas las piezas mviles.\n\n" +
					"Tambin hay 6 Bombas y 1 bandera, que no son mviles. Tenga en cuenta que las piezas mviles tienen un nmero en la esquina superior derecha para designar el orden de rango. Por lo tanto, el mariscal est clasificado con 1 (la ms alta), el general con 2, la 3 coroneles, y as sucesivamente hasta el espa que est marcado con una S.\n\n" +
					"   1. Los jugadores colocan una pieza en cada cuadrado de su mitad del tablero. Todas las plazas se cubrirn a partir de cada extremo. Es decir, 10 por fila, 4 filas de profundidad. Las dos filas intermedias se deben dejar desocupada en el inicio del juego.\n" +
					"   2. Las piezas se colocan con el emblema impreso hacia el jugador de tal manera que el oponente no conoce la disposicin de las piezas.\n" +
					"   3. Lea las reglas de movimiento y ataque y as obtendr una idea de cmo planear la colocacin de las piezas.\n\n" +
					"Reglas de movimiento\n\n" +
					"   1. Resulta alternativo, primero rojo y luego en azul.\n" +
					"   2. Una pieza se mueve de hueco en hueco, un cuadrado a la vez. (Excepcin: Explorador - ver artculo 7). Una pieza puede ser movida hacia adelante, hacia atrs o hacia los lados, pero no en diagonal.\n" +
					"   3. Tenga en cuenta que hay dos lagos en el centro del tablero, que no contienen los cuadrados. Las piezas deben moverse alrededor de los lagos y no pueden moverse donde no hay cuadrado.\n" +
					"   4. Dos piezas no pueden ocupar la misma plaza, al mismo tiempo.\n" +
					"   5. Una pieza no puede moverse a travs de una casilla ocupada por una pieza ni saltar por encima de una pieza.\n" +
					"   6. Slo una pieza puede ser movida en cada turno.\n" +
					"   7. Las piezas bandera y bombas no se pueden mover. Una vez que estas piezas se colocan en el inicio del juego, tendr que permanecer en esa plaza.\n" +
					"   8. El explorador puede moverse a cualquier plaza abierta hacia adelante, hacia atrs o hacia los lados en lnea recta si el jugador lo desea. Este movimiento, por supuesto, revela al oponente el valor de esa pieza. Por lo tanto, el jugador puede elegir mover el explorador slo una casilla en su turno, a fin de mantener la identidad del explorador oculto. El explorador es valioso para sondear las posiciones del oponente.\n" +
					"   9. Una vez que una pieza ha sido movido a un cuadrado y se retira la mano, no se puede mover de nuevo a su posicin original.\n" +
					"  10. Las piezas no se pueden mover hacia atrs y adelante entre los mismos 2 plazas en 3 turnos consecutivos.\n" +
					"  11. Un jugador debe mover o atacar en su turno.\n\n" +
					"Reglas de ataque\n\n" +
					"   1. Cuando una pieza roja o azul ocupan plazas contiguas, ya sea de vuelta a atrs, de lado a lado o cara a cara, es que estn en una posicin para atacar. No hay ataques en diagonal.\n" +
					"   2. Un jugador puede mover en su turno o atacar. l no puede hacer ambas cosas. (Excepcin: explorador - ver regla 13). El ataque termina el turno. Cuando las piezas han terminado en el movimiento de ataque, el jugador que fue golpeado tiene su turno para mover o atacar.\n" +
					"   3. No es necesario que se ataque cuando dos piezas opuestas estn en posicin. Un jugador puede decidir si ataca, siempre que l quiera.\n" +
					"   4. Cualquier jugador puede atacar (a su vez), no slo el que mueve su pieza en su posicin.\n" +
					"   5. Para el ataque, el jugador, al que le toque, toma su pieza y ve la pieza del adversario y, al mismo tiempo que se declara el rango de su pieza. El oponente tiene que nombrar el rango de su pieza.\n" +
					"   6. La pieza con el rango inferior se elimina y se retira del tablero. La pieza ganadora se mueve de inmediato a la plaza vaca que antes ocupaba la pieza que perdi.\n" +
					"   7. Cuando son enfrentadas dos piezas iguales, entonces ambas se pierden y se retiran del tablero.\n" +
					"   8. Un mariscal elimina un general, un general elimina un coronel y un coronel elimina un comandante, y as hasta llegar al espa, que es la pieza de menor rango.\n" +
					"   9. El espa, sin embargo, tiene el privilegio especial de ser capaz de eliminar al mariscal. Es decir, si el espa ataca al mariscal, o este se le ataca. Sin embargo, todas las dems piezas eliminan al espa.\n" +
					"  10. Cuando cualquier pieza (excepto un minero) golpea una bomba (Bang!) Esa pieza se pierde y se retira del tablero. La bomba no se mueve, sino que permanece en su posicin original en todo momento. Cuando un minero ataca una bomba, la bomba se pierde y el minero se traslada a la plaza no ocupada.\n" +
					"  11. Una bomba no puede atacar, sino que debe esperar a que una pieza mvil le ataque.\n" +
					"  12. Recuerde, la bandera nunca se puede mover.\n" +
					"  13. El explorador puede mover y atacar en el mismo turno. Es la nica pieza que puede hacer esto.\n\n" +
					"Para terminar el juego\n\n" +
					"Cada vez que un jugador ataque la bandera de su oponente, el juego termina y l es el ganador. Si un jugador no puede mover una pieza o atacar a su vez, debe renunciar y declarar su oponente ganador.\n\n" +
					"Algunas sugerencias para la estrategia\n\n" +
					"De lo anterior es evidente que la colocacin original de las piezas puede determinar el resultado. Por tanto, es una buena tctica de defensa rodear la bandera con unas cuantas bombas. Sin embargo, para engaar al oponente, se recomienda colocar unas bombas a cierta distancia de la bandera.\n\n" +
					"Algunas piezas de alto rango en las lneas del frente es un buen juego, pero el jugador que pierde rpidamente sus altos cargos se encuentra en una posicin dbil.\n\n" +
					"Los exploradores en la primera lnea son tiles para probar la fuerza de las piezas opuestas.\n\n" +
					"Los mineros son muy importantes cerca del final del juego, por lo que es una buena estrategia para colocar algunos en las filas traseras.\n");
					jTextArea.setWrapStyleWord(true);
					jTextArea.setLineWrap(true);
		}
		return jTextArea;
	}
}
