package juego;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;
import java.util.concurrent.Semaphore;
import java.util.concurrent.locks.ReentrantLock;

import javax.swing.JOptionPane;

import stratego.Tablero;
import stratego.Movimiento;
import stratego.Pieza;
import stratego.Rango;
import stratego.Ajustes;
import stratego.Puntero;



public class IA implements Runnable
{
	private static final double ALPHA = 1;
	private static final int MAX_GUESSES = 3;
	public static ReentrantLock aiLock = new ReentrantLock();
	
	private Tablero board = null;
	private CompControles returnMove = null;
	private int compColor = 0;
	private int userColor = 1;

	private ReentrantLock tLock = new ReentrantLock();
	private Semaphore bLock = new Semaphore(1);
	private static int value = -1;
	private static Movimiento move = null;
	private static TestingTablero tmpB = null;
	private static Movimiento tmpM = null;
	private int turnF = 0;
	
	private BufferedReader cfg = null;
	

	public IA(Tablero b, CompControles u) 
	{
		board = b;
		returnMove = u;
	}
	
	public void setCompColor(int c)
	{
		compColor = c;
		userColor = (c+1)%2;
	}

	public void getMove() 
	{
		new Thread(this).start();
	}
	
	public void getBoardSetup() throws IOException
	{
		File f = new File("ai.cfg");
	    if(!f.exists()) f.createNewFile();
		cfg = new BufferedReader(new FileReader(f));
		ArrayList<String> setup = new ArrayList<String>();

		String fn;
		while ((fn = cfg.readLine()) != null)
			if (!fn.equals("")) setup.add(fn);
		
		while (setup.size() != 0)
		{
			Random rnd = new Random();
			fn = setup.get(rnd.nextInt(setup.size()));
			rnd = null;
			
			BufferedReader in;
			try
			{
			in = new BufferedReader(new FileReader(fn));
			}
			catch (Exception e)
			{
				setup.remove(fn);
				continue;
			}
			
			try
			{
				for (int j=0;j<40;j++)
				{
					int x = in.read(),
						y = in.read();

					if (x<0||x>9||y<0||y>3)
						throw new Exception();
					
					for (int k=0;k<board.getTraySize();k++)
						if (board.getTrayPiece(k).getColor() == compColor)
						{
							returnMove.aiReturnPlace(board.getTrayPiece(k), new Puntero(x, y));
							break;
						}
				}
			}
			catch (IOException e)
			{
				JOptionPane.showMessageDialog(null, "Error de formato de archivo: Archivo inesperado.", 
						"AI", JOptionPane.INFORMATION_MESSAGE);
			}
			catch (Exception e)
			{
				JOptionPane.showMessageDialog(null, "Error de formato de archivo: Estructura de archivo no vlido.", 
						"AI", JOptionPane.INFORMATION_MESSAGE);
			}
			finally
			{
				try {
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			break;
		}
		
		//vuelva a comprobar la configuracin de "ai"
		for (int i=0;i<10;i++)
		for (int j=0;j<4; j++)
		{
			Pieza p = null;
			for (int k=0;k<board.getTraySize();k++)
				if (board.getTrayPiece(k).getColor() == compColor)
				{
					p = board.getTrayPiece(k);
					break;
				}

			if (p==null)
				break;
				
			returnMove.aiReturnPlace(p, new Puntero(i, j));
		}
		
		//Si el usuario no ha terminado de colocar las piezas, simplemente las coloca.
		for (int i=0;i<10;i++)
		for (int j=6;j<10;j++)
		{
			Pieza p = null;
			for (int k=0;k<board.getTraySize();k++)
				if (board.getTrayPiece(k).getColor() != compColor)
				{
					p = board.getTrayPiece(k);
					break;
				}

			if (p==null)
				break;
				
			returnMove.aiReturnPlace(p, new Puntero(i, j));
		}
		
		returnMove.play();
	}

	public void run() 
	{
		aiLock.lock();
		TestingTablero c = new TestingTablero(board);
		Movimiento bestMove = getBestMove(c, Ajustes.aiLevel);
		aiLock.unlock();
		
		move = null;
		tmpB = null;
		tmpM = null;
		System.runFinalization();
		System.gc(); 
		
		returnMove.aiReturnMove(bestMove);
	}
	
	private Movimiento getBestMove(TestingTablero b, int n)
	{
		final int n1 = n-1;
		
		if (n%2==0)
			turnF = 0;
		else
			turnF = 1;

		value = Rango.aiTotalValue() * -3;
		
		Thread threads[] = new Thread[160];
		int threadc = 0;
		
		for (int i=0;i<10;i++)
		for (int j=0;j<10;j++)
		{
			Puntero f = new Puntero(i, j);
			Puntero t = null;
			if (b.getPiece(f) == null)
				continue;
			if (b.getPiece(f).getColor() != compColor)
				continue;
				
			for (int k=0;k<4;k++)
			{
				switch (k)
				{
				case 0:
					if (i==0)
						continue;
					t = new Puntero(i-1, j);
					break;
				case 1:
					if (j==0)
						continue;
					t = new Puntero(i, j-1);
					break;
				case 2:
					if (i==9)
						continue;
					t = new Puntero(i+1, j);
					break;
				case 3:
					if (j==9)
						continue;
					t = new Puntero(i, j+1);
					break;
				}
				if (b.validMove(f, t))
				{
					tmpM = new Movimiento(b.getPiece(f), f, t);
					tmpB = new TestingTablero(b);
					tmpB.move(tmpM);
					threads[threadc] = new Thread()
					{
						public void run()
						{
							TestingTablero mytmpB = tmpB;
							Movimiento mytmpM = tmpM;
							bLock.release();
							int tmpV = valueNMoves(mytmpB, n1, 0);
							tLock.lock();
							if (tmpV > value)
							{
								value = tmpV;
								move = mytmpM;
							}
							tLock.unlock();
						}
					};
					try
					{
						bLock.acquire();
					} catch (InterruptedException e)
					{
						e.printStackTrace();
					}
					threads[threadc].start();
					threadc++;
					try
					{
						bLock.acquire();
					} catch (InterruptedException e)
					{
						e.printStackTrace();
					}
					bLock.release();
				}
			}
		}

		for (int i=0;i<160;i++)
			if (threads[i] != null)
				try
				{
					threads[i].join();
					threads[i] = null;
				}
				catch (InterruptedException e)
				{
					e.printStackTrace();
				}
		
		return move;
	}
	
	private int valueNMoves(TestingTablero b, int n, int guesses)
	{
		if (n<1)
			return valueBoard(b);

		boolean hasMove = false;
		
		int turn;
		if ((turnF + n) % 2 == 0)
			turn = compColor;
		else
			turn = userColor;
				
			
		int value = Rango.aiTotalValue();
		if (turn==compColor)
			value *= -3;
		
		for (int i=0;i<10;i++)
		for (int j=0;j<10;j++)
		{
			Puntero f = new Puntero(i, j);
			Puntero t = null;
			if (b.getPiece(f) == null)
				continue;
			if (b.getPiece(f).getColor() != turn)
				continue;
				
			for (int k=0;k<4;k++)
			{
				switch (k)
				{
				case 0:
					if (j==9)
						continue;
					t = new Puntero(i, j+1);
					break;
				case 1:
					if (i==9)
						continue;
					t = new Puntero(i+1, j);
					break;
				case 2:
					if (i==0)
						continue;
					t = new Puntero(i-1, j);
					break;
				case 3:
					if (j==0)
						continue;
					t = new Puntero(i, j-1);
					break;
				}
				if (b.validMove(f, t))
				{
					hasMove = true;
					
					Movimiento tmpM = new Movimiento(b.getPiece(f), f, t);
					Pieza fp = b.getPiece(f);
					Pieza tp = b.getPiece(t);
					b.move(tmpM);
					//int tmpV = valueBoard(b) + (int)(valueNMoves(b, n-1) * ALPHA);
					int tmpV = valueBoard(b);
					if (tp == null ||
						(fp.isKnown() && turn == userColor) ||
						(tp.isKnown() && turn == compColor))
						tmpV += valueNMoves(b, n-1, guesses);
					else if (guesses <= MAX_GUESSES)
						tmpV += (int) (ALPHA * valueNMoves(b, n-1, guesses+1));
						
					b.undo(fp, f, tp, t);
					if (tmpV > value && turn == compColor)
					{
						value = tmpV;
						if (value > Rango.FLAG.aiValue()/2)
							//Ramas de equipamiento
							return value;
					}
					if (tmpV < value && turn == userColor)
					{
						value = tmpV;
						if (value < (Rango.FLAG.aiValue() * -1)/2)
							//Ramas de equipamiento
							return value;
					}
				}
			}
		}
		if (hasMove)
			return value;
		else
		{
			if (turn==compColor)
				return Rango.aiTotalValue();
			else 
				return -Rango.aiTotalValue();
		}
	}
	
	private int valueBoard(TestingTablero b)
	{
		int value = 0;
		
		for (int i=0;i<b.getTraySize();i++)
		{
			if (b.getTrayPiece(i).getColor() == userColor)
				value += b.getTrayPiece(i).getRank().aiValue();	
			else
				value -= b.getTrayPiece(i).getRank().aiValue();
		}
		
		return value;
	}
}
