package servidor;

import stratego.Tablero;
import stratego.Motor;
import stratego.Movimiento;
import stratego.Puntero;
import stratego.Estados;

public class ServidorMotor extends Motor
{
	private Juego game = null;
	
	public ServidorMotor(Juego g)
	{
		game = g;
		board = new Tablero();
		board.setTopColor(0);
	}
	
	public void play(int color)
	{
		if (status != Estados.SETUP)
			return;
		
		if (board.getTraySize() != 0)
		{
			int l_limit, u_limit;
			if (color == 0)
			{
				l_limit = 0;
				u_limit = 4;
			}
			else
			{
				l_limit = 6;
				u_limit = 10;
			}
			for (int i=0;i<10;i++)
			for (int j=l_limit;j<u_limit;j++)
				if (board.getPiece(i, j) == null)
					for (int k=0;k<board.getTraySize();k++)
						if (getTrayPiece(k).getColor() == color)
							setupPlacePiece(getTrayPiece(k), new Puntero(i, j));
		}
	
		if (board.getTraySize() == 0)
			status = Estados.PLAYING;
	}
	

	public void requestMove(Movimiento m, int color)
	{
		if (m == null) return;
		
		if (status == Estados.PLAYING)
		{
			if (board.getPiece(m.getFrom()) == null) return;
			if (board.getPiece(m.getFrom()).getColor() != color) return;
			
			if (color == turn)
			{
				board.hideAll();
				requestMove(m);
			}
		}
		else if (status == Estados.SETUP)
		{
			if (m.getFrom() == Tablero.IN_TRAY)
			{
				for (int i=0;i<board.getTraySize();i++)
					if (board.getTrayPiece(i).getRank().equals(m.getPiece().getRank()))
						setupPlacePiece(board.getTrayPiece(i), m.getTo());
			}
			else if (m.getTo() == Tablero.IN_TRAY)
			{
				setupRemovePiece(m.getFrom());
				board.hideAll();
			}
			else
			{
				if (setupRemovePiece(m.getFrom()))
					setupPlacePiece(m.getPiece(), m.getTo());
			}
		}
	}
	
	@Override
	protected void gameOver(int winner)
	{
		game.gameOver(winner);
	}

	@Override
	protected void update()
	{
		game.update();
	}

}
