package stratego;

public class Pieza implements Comparable<Pieza>
{
	private int uniqueID = 0;
	private int color = 0;
	private Rango rank = null;
	private boolean shown = false;
	private boolean known = false;

	public Pieza(int id, int c, Rango r) 
	{
		uniqueID = id;
		color = c;
		rank = r;
	}

	public int getColor() 
	{
		return color;
	}

	public Rango getRank() 
	{
		return rank;
	}
	
	public int getID() 
	{
		return uniqueID;
	}
	
	public boolean isShown()
	{
		return shown;
	}
	
	public void setShown(boolean b)
	{
		shown = b;
		if (shown == true)
			known = true;
	}	
	
	public boolean isKnown()
	{
		return known;
	}
	
	public void setKnown(boolean b)
	{
		known = b;
		if (known == false)
			shown = false;
	}

	public int compareTo(Pieza p)
	{
		return uniqueID - p.uniqueID;
	}
	
	public boolean equals(Object p)
	{
		return (uniqueID == ((Pieza)p).uniqueID);
	}
}
